/*
 * pam_log.c -- PAM system logging
 *
 *
 * $Log$
 */

#include <stdarg.h>
#include <stdio.h>
#include <util/message_c.h>

#include <pam/libpam/include/security/_pam_macros.h>
#include <pam/libpam/include/security/_pam_types.h>

#define LOGBUFSIZE 512

void pam_system_log(const pam_handle_t *pamh,
		    const struct pam_log_state *log_state,
		    int priority, const char *format, ... )
{
    va_list args;

    D(("pam_system_log called"));

    va_start(args, format);
    {
	char buf[LOGBUFSIZE];
	int size;
	size = vsnprintf(buf, LOGBUFSIZE, format, args);
	if (size != -1 && size != LOGBUFSIZE) {
	    size = snprintf(buf + size, LOGBUFSIZE - size, "\n");
	}
	if (size == -1 || size == (LOGBUFSIZE - 1)) {
	    buf[LOGBUFSIZE - 1] = 0;
	    buf[LOGBUFSIZE - 2] = '\n';
	}
	message_log(priority, buf);
    }
    va_end(args);

    D(("done."));
}


