#ifndef _SMFPAM_PAM_H_
#define _SMFPAM_PAM_H_

#include <smf/smf/table/pam.smdb.h>

#include <cdb/cdb_iterator.h>
#include <libntaperror/ntap_error.h>
#include <smdb/smdb_iterator.h>

class smf_env;

class pamcfg_iterator : public pamcfg_base_iterator {
  public:
    pamcfg_iterator(smf_env* env) : pamcfg_base_iterator(env) {}
    void default_imp();
    smdb_error notify_imp(smdb_cdb_iterator::operation op);
};

class pamdefault_iterator : public pamdefault_base_iterator {
  public:
    pamdefault_iterator(smf_env* env) : pamdefault_base_iterator(env) {}
    smdb_error get_imp();
    smdb_error next_imp();
  private:
    void getrow(char **nexttok, pamdefault_iterator &row);
};

class pamstate_iterator : public pamstate_base_iterator {
  public:
    pamstate_iterator(smf_env* env) : pamstate_base_iterator(env),
	citr(0), ditr(0) {}
    smdb_error get_imp();
    smdb_error next_imp();
  private:
    pamcfg_iterator citr;
    pamdefault_iterator ditr;
};

class pammods_iterator : public pammods_base_iterator {
  public:
    pammods_iterator(smf_env* env) : pammods_base_iterator(env) {}
    smdb_error get_imp();
    smdb_error next_imp();
};

class authmethods_iterator : public authmethods_base_iterator {
  public:
    authmethods_iterator(smf_env* env) : authmethods_base_iterator(env) {}
    smdb_error get_imp(), next_imp();
};

class authclients_iterator : public authclients_base_iterator {
  public:
    authclients_iterator(smf_env* env) : authclients_base_iterator(env) {}
    smdb_error get_imp(), next_imp();
};

class authmap_iterator : public authmap_base_iterator {
  public:
    authmap_iterator(smf_env* env) : authmap_base_iterator(env) {}
    smdb_error get_imp(), next_imp();
};

#endif // _SMFPAM_PAM_H_
